// #############################
// Prototypes for time functions
// #############################

#include <math.h>
#include "Constants.h"

// Function to convert Julian day number to terrestrial time (TT)
// interval from J2000.0 epoch measured in thousands of Julian years
double JD_to_1000 (double JD);

// Function to convert Julian day number to terrestrial time (TT)
// interval from J2000.0 epoch measured in hundreds of Julian years
double JD_to_100 (double JD);

// Function to convert Julian day number into date
void JuliantoDate (double JD, int& y, int& m, double& d);

// Function to convert date into Julian day number
void DatetoJulian (int Y, int M, double D, double& JD);

// Function to calculate difference between terrestrial dynamic time and universal time
double DeltaT (double t);

// Function to calculate mean Greewich sidereal time (in radians) at date.
double MeanGreenwichSiderealTime (double t);

// Function to convert real day number within month into integer day and time
void DayNumberConvert (double D, int& d, int& h, int& m, int& s);

// Function Convert real day number within month into reduced day number
// corresponding to previous integer half hour.
void DayNumberReduce (double D, double &E);

// Function to convert real time in seconds into integer minutes and seconds
void TimeConvert (double t, int& m, int& s);

// Function to convert realdeclination in radians into integer degrees, minutes, and seconds
void DeclinationConvert (double t, int& d, int& m, int& s);

// Function to convert real right ascension in radians into integer hours, minutes, and seconds
void RightAscensionConvert (double t, int& h, int& m, int& s);


