// ################################################
// Definitions of VSOP87A and ELP2000-82B functions
// ################################################

#include "VSOP_ELP.h"

// ====================================================================
// Functions to return heliocentric rectangular coordinates of planets
// referred to inertial and dynamical ecliptic and equinox J2000.0
// in astronomical units via calls to VSOP87A functions.
// t is Julian day number.
// ====================================================================
double Mercury_X (double t)
{
  double tt = JD_to_1000 (t);
  
  return Mercury_X0 (tt) + Mercury_X1 (tt) + Mercury_X2 (tt) + Mercury_X3 (tt) + Mercury_X4 (tt) + Mercury_X5 (tt);
}
double Mercury_Y (double t)
{
  double tt = JD_to_1000 (t);
  
  return Mercury_Y0 (tt) + Mercury_Y1 (tt) + Mercury_Y2 (tt) + Mercury_Y3 (tt) + Mercury_Y4 (tt) + Mercury_Y5 (tt);
}
double Mercury_Z (double t)
{
  double tt = JD_to_1000 (t);
  
  return Mercury_Z0 (tt) + Mercury_Z1 (tt) + Mercury_Z2 (tt) + Mercury_Z3 (tt) + Mercury_Z4 (tt) + Mercury_Z5 (tt);
}
double Venus_X (double t)
{
  double tt = JD_to_1000 (t);
  
  return Venus_X0 (tt) + Venus_X1 (tt) + Venus_X2 (tt) + Venus_X3 (tt) + Venus_X4 (tt) + Venus_X5 (tt);
}
double Venus_Y (double t)
{
  double tt = JD_to_1000 (t);
  
  return Venus_Y0 (tt) + Venus_Y1 (tt) + Venus_Y2 (tt) + Venus_Y3 (tt) + Venus_Y4 (tt) + Venus_Y5 (tt);
}
double Venus_Z (double t)
{
  double tt = JD_to_1000 (t);
  
  return Venus_Z0 (tt) + Venus_Z1 (tt) + Venus_Z2 (tt) + Venus_Z3 (tt) + Venus_Z4 (tt) + Venus_Z5 (tt);
}
double Earth_X (double t)
{
  double tt = JD_to_1000 (t);
  
  return Earth_X0 (tt) + Earth_X1 (tt) + Earth_X2 (tt) + Earth_X3 (tt) + Earth_X4 (tt) + Earth_X5 (tt);
}
double Earth_Y (double t)
{
  double tt = JD_to_1000 (t);
  
  return Earth_Y0 (tt) + Earth_Y1 (tt) + Earth_Y2 (tt) + Earth_Y3 (tt) + Earth_Y4 (tt) + Earth_Y5 (tt);
}
double Earth_Z (double t)
{
  double tt = JD_to_1000 (t);
  
  return Earth_Z0 (tt) + Earth_Z1 (tt) + Earth_Z2 (tt) + Earth_Z3 (tt) + Earth_Z4 (tt) + Earth_Z5 (tt);
}
double Mars_X (double t)
{
  double tt = JD_to_1000 (t);
  
  return Mars_X0 (tt) + Mars_X1 (tt) + Mars_X2 (tt) + Mars_X3 (tt) + Mars_X4 (tt) + Mars_X5 (tt);
}
double Mars_Y (double t)
{
  double tt = JD_to_1000 (t);
  
  return Mars_Y0 (tt) + Mars_Y1 (tt) + Mars_Y2 (tt) + Mars_Y3 (tt) + Mars_Y4 (tt) + Mars_Y5 (tt);
}
double Mars_Z (double t)
{
  double tt = JD_to_1000 (t);
  
  return Mars_Z0 (tt) + Mars_Z1 (tt) + Mars_Z2 (tt) + Mars_Z3 (tt) + Mars_Z4 (tt) + Mars_Z5 (tt);
}
double Jupiter_X (double t)
{
  double tt = JD_to_1000 (t);
  
  return Jupiter_X0 (tt) + Jupiter_X1 (tt) + Jupiter_X2 (tt) + Jupiter_X3 (tt) + Jupiter_X4 (tt) + Jupiter_X5 (tt);
}
double Jupiter_Y (double t)
{
  double tt = JD_to_1000 (t);
  
  return Jupiter_Y0 (tt) + Jupiter_Y1 (tt) + Jupiter_Y2 (tt) + Jupiter_Y3 (tt) + Jupiter_Y4 (tt) + Jupiter_Y5 (tt);
}
double Jupiter_Z (double t)
{
  double tt = JD_to_1000 (t);
  
  return Jupiter_Z0 (tt) + Jupiter_Z1 (tt) + Jupiter_Z2 (tt) + Jupiter_Z3 (tt) + Jupiter_Z4 (tt) + Jupiter_Z5 (tt);
}
double Saturn_X (double t)
{
  double tt = JD_to_1000 (t);
  
  return Saturn_X0 (tt) + Saturn_X1 (tt) + Saturn_X2 (tt) + Saturn_X3 (tt) + Saturn_X4 (tt) + Saturn_X5 (tt);
}
double Saturn_Y (double t)
{
  double tt = JD_to_1000 (t);
  
  return Saturn_Y0 (tt) + Saturn_Y1 (tt) + Saturn_Y2 (tt) + Saturn_Y3 (tt) + Saturn_Y4 (tt) + Saturn_Y5 (tt);
}
double Saturn_Z (double t)
{
  double tt = JD_to_1000 (t);
  
  return Saturn_Z0 (tt) + Saturn_Z1 (tt) + Saturn_Z2 (tt) + Saturn_Z3 (tt) + Saturn_Z4 (tt) + Saturn_Z5 (tt);
}
double Uranus_X (double t)
{
  double tt = JD_to_1000 (t);
  
  return Uranus_X0 (tt) + Uranus_X1 (tt) + Uranus_X2 (tt) + Uranus_X3 (tt) + Uranus_X4 (tt) + Uranus_X5 (tt);
}
double Uranus_Y (double t)
{
  double tt = JD_to_1000 (t);
  
  return Uranus_Y0 (tt) + Uranus_Y1 (tt) + Uranus_Y2 (tt) + Uranus_Y3 (tt) + Uranus_Y4 (tt) + Uranus_Y5 (tt);
}
double Uranus_Z (double t)
{
  double tt = JD_to_1000 (t);
  
  return Uranus_Z0 (tt) + Uranus_Z1 (tt) + Uranus_Z2 (tt) + Uranus_Z3 (tt) + Uranus_Z4 (tt) + Uranus_Z5 (tt);
}
double Neptune_X (double t)
{
  double tt = JD_to_1000 (t);
  
  return Neptune_X0 (tt) + Neptune_X1 (tt) + Neptune_X2 (tt) + Neptune_X3 (tt) + Neptune_X4 (tt) + Neptune_X5 (tt);
}
double Neptune_Y (double t)
{
  double tt = JD_to_1000 (t);
  
  return Neptune_Y0 (tt) + Neptune_Y1 (tt) + Neptune_Y2 (tt) + Neptune_Y3 (tt) + Neptune_Y4 (tt) + Neptune_Y5 (tt);
}
double Neptune_Z (double t)
{
  double tt = JD_to_1000 (t);
  
  return Neptune_Z0 (tt) + Neptune_Z1 (tt) + Neptune_Z2 (tt) + Neptune_Z3 (tt) + Neptune_Z4 (tt) + Neptune_Z5 (tt);
}

// ====================================================================
// Function to return geocentric rectangular coordinates of Moon
// referred to inertial and dynamical ecliptic and equinox J2000.0
// in astronomical units via calls to ELP2000-82B function.
// t is Julian day number.
// ====================================================================
void Moon (double t, double& x, double& y, double& z)
{
  double XYZ[3];
  
  GetElp82bCoord (t, XYZ);

  x = XYZ[0]; y = XYZ[1]; z = XYZ[2];
}


