// ################################################
// Prototypes for VSOP87A and ELP2000-82B functions
// ################################################

#include "../ELP2000-82B/ELP2000-82B.h"
#include "Time.h"

// VSOP87A functions
double Mercury_X0 (double t); double Mercury_X1 (double t); double Mercury_X2 (double t);
double Mercury_X3 (double t); double Mercury_X4 (double t); double Mercury_X5 (double t);
double Mercury_Y0 (double t); double Mercury_Y1 (double t); double Mercury_Y2 (double t);
double Mercury_Y3 (double t); double Mercury_Y4 (double t); double Mercury_Y5 (double t);
double Mercury_Z0 (double t); double Mercury_Z1 (double t); double Mercury_Z2 (double t);
double Mercury_Z3 (double t); double Mercury_Z4 (double t); double Mercury_Z5 (double t);

double Venus_X0 (double t); double Venus_X1 (double t); double Venus_X2 (double t);
double Venus_X3 (double t); double Venus_X4 (double t); double Venus_X5 (double t);
double Venus_Y0 (double t); double Venus_Y1 (double t); double Venus_Y2 (double t);
double Venus_Y3 (double t); double Venus_Y4 (double t); double Venus_Y5 (double t);
double Venus_Z0 (double t); double Venus_Z1 (double t); double Venus_Z2 (double t);
double Venus_Z3 (double t); double Venus_Z4 (double t); double Venus_Z5 (double t);

double Earth_X0 (double t); double Earth_X1 (double t); double Earth_X2 (double t);
double Earth_X3 (double t); double Earth_X4 (double t); double Earth_X5 (double t);
double Earth_Y0 (double t); double Earth_Y1 (double t); double Earth_Y2 (double t);
double Earth_Y3 (double t); double Earth_Y4 (double t); double Earth_Y5 (double t);
double Earth_Z0 (double t); double Earth_Z1 (double t); double Earth_Z2 (double t);
double Earth_Z3 (double t); double Earth_Z4 (double t); double Earth_Z5 (double t);

double Mars_X0 (double t); double Mars_X1 (double t); double Mars_X2 (double t);
double Mars_X3 (double t); double Mars_X4 (double t); double Mars_X5 (double t);
double Mars_Y0 (double t); double Mars_Y1 (double t); double Mars_Y2 (double t);
double Mars_Y3 (double t); double Mars_Y4 (double t); double Mars_Y5 (double t);
double Mars_Z0 (double t); double Mars_Z1 (double t); double Mars_Z2 (double t);
double Mars_Z3 (double t); double Mars_Z4 (double t); double Mars_Z5 (double t);

double Jupiter_X0 (double t); double Jupiter_X1 (double t); double Jupiter_X2 (double t);
double Jupiter_X3 (double t); double Jupiter_X4 (double t); double Jupiter_X5 (double t);
double Jupiter_Y0 (double t); double Jupiter_Y1 (double t); double Jupiter_Y2 (double t);
double Jupiter_Y3 (double t); double Jupiter_Y4 (double t); double Jupiter_Y5 (double t);
double Jupiter_Z0 (double t); double Jupiter_Z1 (double t); double Jupiter_Z2 (double t);
double Jupiter_Z3 (double t); double Jupiter_Z4 (double t); double Jupiter_Z5 (double t);

double Saturn_X0 (double t); double Saturn_X1 (double t); double Saturn_X2 (double t);
double Saturn_X3 (double t); double Saturn_X4 (double t); double Saturn_X5 (double t);
double Saturn_Y0 (double t); double Saturn_Y1 (double t); double Saturn_Y2 (double t);
double Saturn_Y3 (double t); double Saturn_Y4 (double t); double Saturn_Y5 (double t);
double Saturn_Z0 (double t); double Saturn_Z1 (double t); double Saturn_Z2 (double t);
double Saturn_Z3 (double t); double Saturn_Z4 (double t); double Saturn_Z5 (double t);

double Uranus_X0 (double t); double Uranus_X1 (double t); double Uranus_X2 (double t);
double Uranus_X3 (double t); double Uranus_X4 (double t); double Uranus_X5 (double t);
double Uranus_Y0 (double t); double Uranus_Y1 (double t); double Uranus_Y2 (double t);
double Uranus_Y3 (double t); double Uranus_Y4 (double t); double Uranus_Y5 (double t);
double Uranus_Z0 (double t); double Uranus_Z1 (double t); double Uranus_Z2 (double t);
double Uranus_Z3 (double t); double Uranus_Z4 (double t); double Uranus_Z5 (double t);

double Neptune_X0 (double t); double Neptune_X1 (double t); double Neptune_X2 (double t);
double Neptune_X3 (double t); double Neptune_X4 (double t); double Neptune_X5 (double t);
double Neptune_Y0 (double t); double Neptune_Y1 (double t); double Neptune_Y2 (double t);
double Neptune_Y3 (double t); double Neptune_Y4 (double t); double Neptune_Y5 (double t);
double Neptune_Z0 (double t); double Neptune_Z1 (double t); double Neptune_Z2 (double t);
double Neptune_Z3 (double t); double Neptune_Z4 (double t); double Neptune_Z5 (double t);

// Functions to return heliocentric rectangular coordinates of planets referred to
// inertial and dynamical ecliptic and equinox J2000.0 in astronomical units
double Mercury_X (double t); double Mercury_Y (double t); double Mercury_Z (double t);
double Venus_X   (double t); double Venus_Y   (double t); double Venus_Z   (double t);
double Earth_X   (double t); double Earth_Y   (double t); double Earth_Z   (double t);
double Mars_X    (double t); double Mars_Y    (double t); double Mars_Z    (double t);
double Jupiter_X (double t); double Jupiter_Y (double t); double Jupiter_Z (double t);
double Saturn_X  (double t); double Saturn_Y  (double t); double Saturn_Z  (double t);
double Uranus_X  (double t); double Uranus_Y  (double t); double Uranus_Z  (double t);
double Neptune_X (double t); double Neptune_Y (double t); double Neptune_Z (double t);

// ELP2000-82B function
void Moon (double t, double& x, double& y, double& z);
